// JavaScript source code

window.console = window.console || (function () {
    var c = {};
    c.log = c.warn = c.debug = c.info = c.error = c.time = c.dir = c.profile = c.clear = c.exception = c.trace = c.assert = function () {
        alert("IE 8 等低版本中不支持使用console类对象，请升级IE浏览器， 注释此弹窗请打开websvr_facility.js");
    };
    return c;
})();

//底层输出
function log_internal(content) {
    var new_node = $("<p>");
    new_node.append(content);
    $("#log_content").append(new_node);
}

//普通输出
var normal_log = log_internal;

//错误输出
function error_log(content) {
    log_internal($("<p style='color:red; margin:10px 5px 10px 20px;'>" + content + "</p>"));
}

//正确输出
function success_log(content) {
    log_internal($("<p style='color:green; margin:10px 5px 10px 20px;'>" + content + "</p>"));
}

//信息输出
function info_log(content) {
    log_internal($("<p style='color:gray; margin:10px 5px 10px 20px;'>" + content + "</p>"));
}

//测试用例对象
function TestUser(case_name) {
    var testuser = new Object();
    testuser.name = case_name;

    testuser.onStart = function () {
        return true;
    }
    
    testuser.onStop = function () {

    }

    testuser.element = new Array();

    //添加测试函数
    testuser.add_test = function (test_fun) {
        testuser.element.push(test_fun);
    }

    return testuser;
}

//调用测试用例
function test_all(testuser) {
    try {
        var info = "开始执行测试: ";
        if (testuser.name != undefined && testuser.name != "")
            info = info + testuser.name;
        normal_log(info);

        if (testuser.onStart()) {
            for (var i = 0; i < testuser.element.length; i++)
                testuser.element[i]();

            log_internal("共有测试元素 " + testuser.element.length + "个");
        }

        testuser.onStop();

        var info = "结束执行测试: ";
        if (testuser.name != undefined && testuser.name != "")
            info = info + testuser.name;
        normal_log(info);

    } catch (err) {
        error_log("代码执行异常: \n");
        error_log(err.stack.replace("\n", "<br/>"));
    }
}