package com.sense.demo;

import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.servlet.ModelAndView;
import sun.misc.BASE64Decoder;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.security.PublicKey;
import java.security.Signature;
import java.security.Timestamp;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import java.util.Collection;
import java.util.Iterator;

@RestController
public class Demo {

    @RequestMapping(value="/test")
    public ModelAndView sayHello(HttpServletRequest request){
        //此处生成32位随机数 返回前台login页面(随机数生成由时间戳以及12位随机数组成)
        String  random_number =new TimeStamp().getTimeRand() + new TimeStamp().getRandom(12);
        HttpSession session =request.getSession();
        session.setAttribute("random",random_number);
        ModelAndView mav = new ModelAndView("login");
        return mav;
    }


    @RequestMapping(value="/checkValid")
    public String checkValid(HttpServletRequest request)  throws Exception {
        HttpSession session = request.getSession();
       //页面拿到的随机数原始数据，需在随机数前面加上SENSELOCK
        String ss = "SENSELOCK" + (String) session.getAttribute("random_number");
        //锁外壳号
        String shell_num = request.getParameter("shell_num");
        //锁序列号
        String lock_sn = request.getParameter("lock_sn");
        //锁证书
        String lock_cert = request.getParameter("lock_cert");
        //证书链
        String device_certs = request.getParameter("device_certs");
		//此处获取到的是公开区数据，拿到数据可以自行操作处理
        String pub_data = request.getParameter("pub_data");
        //页面签名之后的数据
        String verify_data = request.getParameter("verify_data");
       

        //此处读取的是p7b证书。并解析出证书中的公钥。
        File f = new File(
                "C:\\Users\\Administrator\\Desktop\\sense.p7b");
        byte[] buffer = new byte[(int) f.length()];
        DataInputStream in = new DataInputStream(new FileInputStream(f));
        in.readFully(buffer);
        in.close();
        String str = byteArrayToStr(buffer);
        byte[] p7b = decryptBASE64(str);
        Collection<X509Certificate> certificates = (Collection<X509Certificate>) CertificateFactory
                .getInstance("X.509")
                .generateCertificates(new ByteArrayInputStream(p7b));
        Iterator<X509Certificate> iterator = certificates.iterator();
        while (iterator.hasNext()){
            X509Certificate certificate = iterator.next();
            PublicKey publicKey = certificate.getPublicKey();
            if(certificate.getSubjectDN().getName().startsWith("CN=DEVICEID")){
                Signature signature2 = Signature.getInstance("SHA1WithRSA");
                signature2.initVerify(publicKey);
                signature2.update(ss.getBytes("UTF-8"));
                boolean verify = signature2.verify(decryptBASE64(verify_data));
                    if(verify){
                        System.out.println("解密成功");
                }else{
                    System.out.println("解密失败");
                }
                break;
            }
        }

        return "Success";
    }

    public static byte[] decryptBASE64(String key) throws Exception {
        return (new BASE64Decoder()).decodeBuffer(key);
    }

    public static String byteArrayToStr(byte[] byteArray) {
        if (byteArray == null) {
            return null;
        }
        String str = new String(byteArray);
        return str;
    }

    public static byte[] strToByteArray(String str) {
        if (str == null) {
            return null;
        }
        byte[] byteArray = str.getBytes();
        return byteArray;
    }
}
